#!/usr/bin/env python

#quick hack to for a speak server for navigation commands
#run: python speak.py [language]
#      language can be english (default) or german

#use: http://localhost/turn_left
#     http://localhost/turn_right

# needs espeak installed

from BaseHTTPServer import BaseHTTPRequestHandler
import SocketServer,os,sys
from subprocess import Popen

PORT = 9999

if len(sys.argv) < 2:
    language = 'english'
else:
    language = sys.argv[1]

commands = dict(turn_left=dict(english='please turn left',
                               german='bitte links fahren '),
                turn_right=dict(english='please turn right',
                german='bitte rechts fahren '))

class OurServer(SocketServer.TCPServer):
    allow_reuse_address = True


class TalkHandler(BaseHTTPRequestHandler):

    def do_GET(self):
        path = self.path
        talk = 'error'
        parts = path.split('/')

        command = parts[-1]
        command = command.replace("%20", ", ");
        if getattr(self.server,'speakpid',None):
            os.kill(self.server.speakpid,9)
            os.waitpid(self.server.speakpid,0)
        self.server.speakpid = Popen(['/usr/bin/espeak',"-v",language,command]).pid

        self.send_response(200)
        self.send_header('Content-type', 'text/plain')
        self.end_headers()

        self.wfile.write(str(command))
        self.wfile.flush()
        self.connection.shutdown(1)


httpd = OurServer(("", PORT), TalkHandler)

print "serving at port %s in %s" % (PORT, language)
httpd.serve_forever()

